package com.taco.debug.gui;

import java.awt.Component;
import java.awt.Dimension;

import javax.swing.*;
import javax.swing.tree.*;

public class BeanTree extends JTree {
    public BeanTree(String name, Object obj) {
        super(new BeanTreeNode(name, obj));
        setCellRenderer(new BeanTreeCellRenderer());
    }
    
    public static class BeanTreeCellRenderer extends DefaultTreeCellRenderer {
        public BeanTreeCellRenderer() {
            super();
        }
        
        public Component getTreeCellRendererComponent(JTree tree, Object value, 
          boolean sel, boolean expanded, boolean leaf, int row,
          boolean hasFocus) { 
            super.getTreeCellRendererComponent(tree, value, sel, expanded, 
              leaf, row, hasFocus);
 
            BeanTreeNode node = (BeanTreeNode) value;
            
            // Set the icon if available.
            Icon icon = node.getIcon();            
            if (icon != null) {
                setIcon(icon);
            }
            
            setText(node.getName() + " : " + node.getObject()); 

            // Return the label that I am.
            return this;             
        }
    }            
    
    public static void main(String[] args) {
        BeanTree tree = new BeanTree("panel", new JPanel());
        
        JFrame frame = new JFrame();
        frame.setContentPane(new JScrollPane(tree));       
        frame.pack();
        frame.setSize(new Dimension(550, 450));
        frame.setVisible(true);       
    }
}
